From f066c0e32271856fbe22edbff2bf88e4630f1748 Mon Sep 17 00:00:00 2001
From: Egbert Eich <eich@suse.com>
Date: Mon, 16 May 2022 14:33:14 +0200
Subject: [PATCH 22/34] Replace response_init()

Signed-off-by: Egbert Eich <eich@suse.com>
---
 src/slurmctld/job_mgr.c  |  4 +++
 src/slurmctld/proc_req.c | 68 ++++++++++++++++++++++++++++++++++++++++
 2 files changed, 72 insertions(+)

diff --git a/src/slurmctld/job_mgr.c b/src/slurmctld/job_mgr.c
index 28c87d0c80..500c3b868f 100644
--- a/src/slurmctld/job_mgr.c
+++ b/src/slurmctld/job_mgr.c
@@ -12491,6 +12491,8 @@ extern int update_job_str(slurm_msg_t *msg, uid_t uid)
 reply:
 	if ((rc != ESLURM_JOB_SETTING_DB_INX) && (msg->conn_fd >= 0)) {
 	        slurm_msg_t_init(&resp_msg);
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&resp_msg, msg->auth_uid);
 		if (resp_array) {
 			resp_array_msg = _resp_array_xlate(resp_array, job_id);
 			resp_msg.msg_type  = RESPONSE_JOB_ARRAY_ERRORS;
@@ -14847,6 +14849,8 @@ extern int job_requeue2(uid_t uid, requeue_msg_t *req_ptr, slurm_msg_t *msg,
     reply:
 	if (msg) {
 		slurm_msg_t_init(&resp_msg);
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&resp_msg, msg->auth_uid);
 		resp_msg.protocol_version = msg->protocol_version;
 		resp_msg.conn             = msg->conn;
 		if (resp_array) {
diff --git a/src/slurmctld/proc_req.c b/src/slurmctld/proc_req.c
index 1158f2739c..04bf9d3c88 100644
--- a/src/slurmctld/proc_req.c
+++ b/src/slurmctld/proc_req.c
@@ -1257,6 +1257,8 @@ static void _slurm_rpc_allocate_resources(slurm_msg_t * msg)
 		response_msg.conn = msg->conn;
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		     slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.msg_type = RESPONSE_RESOURCE_ALLOCATION;
 		response_msg.data = &alloc_msg;
 
@@ -1317,6 +1319,8 @@ static void _slurm_rpc_dump_conf(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_BUILD_INFO;
@@ -1365,6 +1369,8 @@ static void _slurm_rpc_dump_jobs(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_JOB_INFO;
@@ -1407,6 +1413,8 @@ static void _slurm_rpc_dump_jobs_user(slurm_msg_t * msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address = msg->address;
 	response_msg.conn = msg->conn;
 	response_msg.msg_type = RESPONSE_JOB_INFO;
@@ -1451,6 +1459,8 @@ static void _slurm_rpc_dump_job_single(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_JOB_INFO;
@@ -1480,6 +1490,8 @@ static void  _slurm_rpc_get_shares(slurm_msg_t *msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address  = msg->address;
 	response_msg.conn     = msg->conn;
 	response_msg.msg_type = RESPONSE_SHARE_INFO;
@@ -1509,6 +1521,8 @@ static void  _slurm_rpc_get_priority_factors(slurm_msg_t *msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address  = msg->address;
 	response_msg.conn     = msg->conn;
 	response_msg.msg_type = RESPONSE_PRIORITY_FACTORS;
@@ -1547,6 +1561,8 @@ static void _slurm_rpc_end_time(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address  = msg->address;
 		response_msg.conn     = msg->conn;
 		response_msg.msg_type = SRUN_TIMEOUT;
@@ -1575,6 +1591,8 @@ static void _slurm_rpc_get_fed(slurm_msg_t * msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address = msg->address;
 	response_msg.conn = msg->conn;
 	response_msg.msg_type = RESPONSE_FED_INFO;
@@ -1623,6 +1641,8 @@ static void _slurm_rpc_dump_front_end(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_FRONT_END_INFO;
@@ -1683,6 +1703,8 @@ static void _slurm_rpc_dump_nodes(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_NODE_INFO;
@@ -1741,6 +1763,8 @@ static void _slurm_rpc_dump_node_single(slurm_msg_t * msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address = msg->address;
 	response_msg.conn = msg->conn;
 	response_msg.msg_type = RESPONSE_NODE_INFO;
@@ -1794,6 +1818,8 @@ static void _slurm_rpc_dump_partitions(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_PARTITION_INFO;
@@ -2465,6 +2491,8 @@ static void _slurm_rpc_job_step_create(slurm_msg_t * msg)
 		slurm_msg_t_init(&resp);
 		resp.flags = msg->flags;
 		resp.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&resp, msg->auth_uid);
 		resp.address = msg->address;
 		resp.conn = msg->conn;
 		resp.msg_type = RESPONSE_JOB_STEP_CREATE;
@@ -2534,6 +2562,8 @@ static void _slurm_rpc_job_step_get_info(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_JOB_STEP_INFO;
@@ -2660,6 +2690,8 @@ static void _slurm_rpc_job_will_run(slurm_msg_t * msg, bool allow_sibs)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_JOB_WILL_RUN;
@@ -2853,6 +2885,8 @@ static void _slurm_rpc_job_alloc_info(slurm_msg_t * msg)
 		response_msg.protocol_version = msg->protocol_version;
 		response_msg.msg_type    = RESPONSE_JOB_ALLOCATION_INFO;
 		response_msg.data        = &job_info_resp_msg;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 
 		slurm_send_node_msg(msg->conn_fd, &response_msg);
 		select_g_select_jobinfo_free(job_info_resp_msg.select_jobinfo);
@@ -3123,6 +3157,8 @@ static void _slurm_rpc_job_sbcast_cred(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.msg_type    = RESPONSE_JOB_SBCAST_CRED;
 		response_msg.data        = &job_info_resp_msg;
 
@@ -3490,6 +3526,8 @@ static void _slurm_rpc_step_layout(slurm_msg_t *msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.msg_type    = RESPONSE_STEP_LAYOUT;
 	response_msg.data        = step_layout;
 
@@ -3718,6 +3756,8 @@ send_msg:
 		submit_msg.job_id     = job_id;
 		submit_msg.step_id    = step_id;
 		submit_msg.error_code = error_code;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.msg_type = RESPONSE_SUBMIT_BATCH_JOB;
 		response_msg.data = &submit_msg;
 		slurm_send_node_msg(msg->conn_fd, &response_msg);
@@ -4222,6 +4262,8 @@ static void _slurm_rpc_resv_create(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		resv_resp_msg.name    = resv_desc_ptr->name;
 		response_msg.msg_type = RESPONSE_CREATE_RESERVATION;
 		response_msg.data     = &resv_resp_msg;
@@ -4352,6 +4394,8 @@ static void _slurm_rpc_resv_show(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_RESERVATION_INFO;
@@ -4408,6 +4452,8 @@ static void _slurm_rpc_layout_show(slurm_msg_t * msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address = msg->address;
 	response_msg.conn = msg->conn;
 	response_msg.msg_type = RESPONSE_LAYOUT_INFO;
@@ -4500,6 +4546,8 @@ static void _slurm_rpc_job_ready(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		rc_msg.return_code = result;
@@ -4615,6 +4663,8 @@ static void  _slurm_rpc_burst_buffer_info(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_BURST_BUFFER_INFO;
@@ -5178,6 +5228,8 @@ inline static void  _slurm_rpc_trigger_get(slurm_msg_t * msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address  = msg->address;
 	response_msg.conn     = msg->conn;
 	response_msg.msg_type = RESPONSE_TRIGGER_GET;
@@ -5265,6 +5317,8 @@ inline static void  _slurm_rpc_get_topo(slurm_msg_t * msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address  = msg->address;
 	response_msg.conn     = msg->conn;
 	response_msg.msg_type = RESPONSE_TOPO_INFO;
@@ -5297,6 +5351,8 @@ inline static void  _slurm_rpc_get_powercap(slurm_msg_t * msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address  = msg->address;
 	response_msg.conn     = msg->conn;
 	response_msg.msg_type = RESPONSE_POWERCAP_INFO;
@@ -5743,6 +5799,8 @@ inline static void _slurm_rpc_dump_spank(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address  = msg->address;
 		response_msg.conn     = msg->conn;
 		response_msg.msg_type = RESPONCE_SPANK_ENVIRONMENT;
@@ -5829,6 +5887,8 @@ inline static void _slurm_rpc_dump_stats(slurm_msg_t * msg)
 
 	slurm_msg_t_init(&response_msg);
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address = msg->address;
 	response_msg.conn = msg->conn;
 	response_msg.msg_type = RESPONSE_STATS_INFO;
@@ -5892,6 +5952,8 @@ _slurm_rpc_dump_licenses(slurm_msg_t * msg)
 
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address = msg->address;
 	response_msg.conn = msg->conn;
 	response_msg.msg_type = RESPONSE_LICENSE_INFO;
@@ -6051,6 +6113,8 @@ static void  _slurm_rpc_composite_msg(slurm_msg_t *msg)
 		slurm_msg_t_init(&resp_msg);
 		resp_msg.flags    = msg->flags;
 		resp_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&resp_msg, msg->auth_uid);
 		memcpy(&resp_msg.address, &comp_msg->sender,
 		       sizeof(slurm_addr_t));
 		resp_msg.msg_type = RESPONSE_MESSAGE_COMPOSITE;
@@ -6135,6 +6199,8 @@ static void  _slurm_rpc_comp_msg_list(composite_msg_t * comp_msg,
 				resp_msg->flags = next_msg->flags;
 				resp_msg->protocol_version =
 					next_msg->protocol_version;
+				if (next_msg->auth_uid_set)
+				  slurm_msg_set_r_uid(resp_msg, next_msg->auth_uid);
 				resp_msg->msg_type = RESPONSE_MESSAGE_COMPOSITE;
 				/* You can't just set the
 				 * resp_msg->address here, it won't
@@ -6210,6 +6276,8 @@ static void _slurm_rpc_assoc_mgr_info(slurm_msg_t * msg)
 
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address = msg->address;
 	response_msg.conn = msg->conn;
 	response_msg.msg_type = RESPONSE_ASSOC_MGR_INFO;
-- 
2.35.3


